import { Component, NgZone } from '@angular/core';  
import { Message } from './models/message';  
import { ChatService } from './services/chat.service';  
  
@Component({  
  selector: 'app-root',  
  templateUrl: './app.component.html',  
  styleUrls: ['./app.component.css']  
})  
export class AppComponent {  
  
  title = 'ClientApp';  
  txtMessage: string = '';    
  txtsubcriberId : string = '';  
  txtsubcriberUnitId : string = '';  
  lblmsg :string = "";
  txtMSend :string = "";
  txtGroup :string = "";

  uniqueID: string = new Date().getTime().toString();  
  messages = new Array<Message>();  
  message = new Message();  

  constructor(  
    private chatService: ChatService,  
    private _ngZone: NgZone     
  ) {  
    this.subscribeToEvents();  
  }  

  sendMessage(): void {  
    if (this.txtMessage) {  
      this.message = new Message();  
      this.message.clientuniqueid = this.uniqueID;      
      this.message.type = "sent";  
      this.message.message = this.txtMessage;  
      this.message.date = new Date();  
      this.message.subcriberId = this.txtsubcriberId;
      this.message.subcriberUnitId = this.txtsubcriberUnitId;
      this.message.MSend = this.txtMSend ;
      this.message.Group = this.txtGroup ;
      this.messages.push(this.message);      
      this.chatService.sendMessage(this.message);  
      this.txtMessage = '';  
    }  
  }  
  
  
  sendMessageOnetoOne(): void {  
    if (this.txtMessage) {  
      this.message = new Message();  
      this.message.clientuniqueid = this.uniqueID;       
      this.message.type = "sent";  
      this.message.message = this.txtMessage;  
      this.message.date = new Date();  
      this.message.MSend = this.txtMSend ;
      this.message.Group = this.txtGroup ;
      this.messages.push(this.message);  
      this.chatService.sendMessageOnetoOne(this.message);       
      this.txtMessage = '';  
    }  
  } 

  sendMessagetoGroup(): void {  
    if (this.txtMessage) {  
      this.message = new Message();  
      this.message.clientuniqueid = this.uniqueID;        
      this.message.type = "sent";  
      this.message.message = this.txtMessage;  
      this.message.date = new Date();  
      this.message.MSend = this.txtMSend ;
      this.message.Group = this.txtGroup ;
      this.messages.push(this.message);  
      this.chatService.sendMessagetoGroup(this.message);  
      this.txtMessage = '';  
    }  
  } 

  JoinGroup(): void {   
    this.message = new Message();  
    this.message.clientuniqueid = this.uniqueID;        
    this.message.type = "sent";  
    this.message.message = this.txtMessage;  
    this.message.date = new Date();  
    this.message.MSend = this.txtMSend ;
    this.message.Group = this.txtGroup ;    
    this.chatService.JoinGroup(this.message);      
  } 


  LeaveGroup(): void {      
    this.message = new Message();  
    this.message.clientuniqueid = this.uniqueID;        
    this.message.type = "sent";  
    this.message.message = this.txtMessage;  
    this.message.date = new Date();  
    this.message.MSend = this.txtMSend ;
    this.message.Group = this.txtGroup ;    
    this.chatService.LeaveGroup(this.message);      
} 


  StartCreateConnection(): void {  
    if (this.txtMessage) {  
      this.message = new Message();  
      this.message.Group = "Test";  
      this.message.clientuniqueid = this.uniqueID;  
      this.message.type = "sent";  
      this.message.message = this.txtMessage;  
      this.message.date = new Date();  
      this.message.subcriberId = this.txtsubcriberId;
      this.message.subcriberUnitId = this.txtsubcriberUnitId;
      this.message.MSend = this.txtMSend ;
      this.message.Group = this.txtGroup ;
      this.messages.push(this.message);          
      this.chatService.createConnection();  
      this.chatService.registerOnServerEvents();  
      this.chatService.ConnectionMessage();        
      this.chatService.startConnection(this.message);       
      this.txtMessage = ''; 
     }  
  } 


  private subscribeToEvents(): void {
    this.chatService.messageReceived.subscribe((message: Message) => {  
      this._ngZone.run(() => {  
        if (message.clientuniqueid !== this.uniqueID) {  
          message.type = "received";  
          this.messages.push(message);  
        }  
      });  
    });  
  }  
}  