import { EventEmitter, Injectable } from '@angular/core';  
import { HubConnection, HubConnectionBuilder } from '@aspnet/signalr';  
import { Message } from '../models/message';  
import { HttpClient,HttpHeaders} from '@angular/common/http';
  
@Injectable()  
export class ChatService {  
  messageReceived = new EventEmitter<Message>();  
  connectionEstablished = new EventEmitter<Boolean>();  
  
  private connectionIsEstablished = false;  
  private _hubConnection: HubConnection;  
  public connectionId : string;
  public TotalCurrentConnection : string;
  public data: string;
  
  
  

  constructor( private http: HttpClient) {  
    // this.createConnection();  
    // this.registerOnServerEvents();  
    // this.startConnection();    
  }  
  
  sendMessage(message: Message) {        
    const headers = new HttpHeaders({ 'Content-Type': 'application/json' });
    this.http.post<any>('https://localhost:5001/api/Chart/NewMessage', {
      clientuniqueid :  message.clientuniqueid ,
      type:'sent',
      message :message.message,
      date: new Date(),
      subcriberId:message.subcriberId,
      subcriberUnitId:message.subcriberUnitId,
      MSend:message.MSend,
      Group:message.Group,     
  },{ headers: headers }).subscribe(res => {
      console.log(res);
    });
  }  

  
  sendMessageOnetoOne(message: Message) {           
    const headers = new HttpHeaders({ 'Content-Type': 'application/json' });
    this.http.post<any>('https://localhost:5001/api/Chart/OnetoOneMessage', {
      clientuniqueid :  message.clientuniqueid ,
      type:'sent',
      message :message.message,
      date: new Date(),
      subcriberId:message.subcriberId,
      subcriberUnitId:message.subcriberUnitId,
      MSend:message.MSend,
      Group:message.Group,     
  },{ headers: headers }).subscribe(res => {
      console.log(res);
    });

  } 

  JoinGroup(message: Message) {           
    const headers = new HttpHeaders({'Content-Type': 'application/json' });
    this.http.post<any>('https://localhost:5001/api/Chart/JoinGroup', {
      clientuniqueid :  message.clientuniqueid ,
      type:'sent',
      message :message.message,
      date: new Date(),
      subcriberId:message.subcriberId,
      subcriberUnitId:message.subcriberUnitId,
      MSend:message.MSend,
      Group:message.Group,     
  },{ headers: headers }).subscribe(res => {
      console.log(res);
    });
  } 

  LeaveGroup(message: Message) {           
    const headers = new HttpHeaders({ 'Content-Type': 'application/json' });
    this.http.post<any>('https://localhost:5001/api/Chart/LeaveGroup', {
      clientuniqueid :  message.clientuniqueid ,
      type:'sent',
      message :message.message,
      date: new Date(),
      subcriberId:message.subcriberId,
      subcriberUnitId:message.subcriberUnitId,
      MSend:message.MSend,
      Group:message.Group,     
  },{ headers: headers }).subscribe(res => {
      console.log(res);
    });
    
  } 

  sendMessagetoGroup(message: Message) {     
    const headers = new HttpHeaders({ 'Content-Type': 'application/json' });
    this.http.post<any>('https://localhost:5001/api/Chart/sendMessagetoGroup', {
      clientuniqueid :  message.clientuniqueid ,
      type:'sent',
      message :message.message,
      date: new Date(),
      subcriberId:message.subcriberId,
      subcriberUnitId:message.subcriberUnitId,
      MSend:message.MSend,
      Group:message.Group,     
  },{ headers: headers }).subscribe(res => {
      console.log(res);
    });
    
  } 

  
  public createConnection() {  
    this._hubConnection = new HubConnectionBuilder()      
      .withUrl('https://localhost:5001/MessageHub')
      .build();  
  }  
  
  public startConnection(message: Message): void {  
    // message.clientuniqueid =this.connectionId;      
    this._hubConnection  
      .start()  
      .then(() => {  
        this.connectionIsEstablished = true;  
        console.log('Hub connection started');  
        this.connectionEstablished.emit(true);  
      })
      .then(() => this.getConnectionId())
      .then(() => this.PassPreData(message))
      .catch(err => {  
        console.log('Error while establishing connection, retrying...');          
      });
           

  }  

  public getConnectionId = () => {
    this._hubConnection.invoke('getconnectionid'); 
  }

  public PassPreData = (message: Message) => {
   this._hubConnection.invoke('PassPreData',message);    
  }
  
  public registerOnServerEvents(): void {  
    this._hubConnection.on('OnetoOneMessageMessageReceived', (data: any) => {         
      console.log(data);     
      this.messageReceived.emit(data);  
    });  
  } 
  
  public ConnectionMessage(): void {  
    this._hubConnection.on('ConnectionMessage', (data: any) => {         
      console.log(data);     
           
    });  
  } 
   
}   