﻿using Microsoft.AspNet.SignalR.Hubs;
using Microsoft.AspNetCore.SignalR;
using SignalRHubsAPIs.DataStorage;
using SignalRHubsAPIs.Models;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace SignalRHubsAPIs.HubConfig
{
    [HubName("MessageHub")]
    public class MessageHub : Hub
    {
        public string getconnectionid() => Context.ConnectionId;

        public async Task PassPreData(Message msg)
        {
            Message message = new Message();
            message.message = "Stored Connection.";
            SubscriberHandler.SubscriberConnectedIds.Add(Context.ConnectionId, new List<string>() { msg.clientuniqueid,msg.subcriberId, msg.subcriberUnitId });
            await Clients.Client(Context.ConnectionId).SendAsync("ConnectionMessage", message);
        }

        public override Task OnConnectedAsync()
        {
            //UserHandler.ConnectedIds.Add(Context.ConnectionId);
            return base.OnConnectedAsync();
        }

        public override Task OnDisconnectedAsync(Exception exception)
        {
            

            if (SubscriberHandler.SubscriberConnectedIds.ContainsKey(Context.ConnectionId))
            {
                SubscriberHandler.SubscriberConnectedIds.Remove(Context.ConnectionId);
            }
            return base.OnDisconnectedAsync(exception);
        }      

    }


}




